<?php
/*
Plugin Name: Barack Obama Sidebar Widget
Plugin URI: http://mindsharestudios.com/downloads/barack-obama-sidebar-widget/
Description: A Barack Obama widget that displays an Obama badge and the latest news from <a href="http://www.barackobama.com/">www.barackobama.com</a>.
Version: 0.3
Author: Mindshare Studios, Inc
Author URI: http://mindsharestudios.com/
*/

/*	
	This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

	Copyright 2008, Mindshare Studios, Inc.
	
*/

/*
	Changes

	- 0.2.1, removed empty <p> if no title is present, updated FAQ
	- 0.3, added ability to choose badge emblem
*/

$pics=array(
"Blue on White 150*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalblueonwhite.jpg",
"Logo Badge 150*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalcolor.jpg",
"Logo Badge on Blue 150*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalcoloronblue.jpg",
"I Support Barack Obama 150*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalsupport.jpg",
"I'm Voting for Barack Obama 150*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalvoting.jpg",
"Logo White on Blue 150*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalwhiteonblue.jpg",
"Change We Can Believe In 127*200"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/vertchange.jpg",
"Obama '08 Red and Blue 127*200"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/vertjfk.jpg",
"Obama '08 Blue 127*200"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/vertobama.jpg",
"White Logo with URL on Blue 200*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/widebluelogo.jpg",
"Color Logo with URL on Blue 200*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/widecolorlogo.jpg",
"Red and Blue with URL 200*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/widejfk.jpg",
"Blue with URL 200*127"=>"http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/wideobama.jpg"
);

function obama_badge_widget_getRSS($url, $numitems = '5', $before='<li class="obama">', $after='</li>') {
	if(!is_null($url)) {
		require_once(ABSPATH. "wp-includes/rss-functions.php");
		$rss = fetch_rss($url);
		if($rss) {
			foreach(array_slice($rss->items,0,$numitems) as $item) {
				echo "$before<a title=\"".htmlentities($item['title'])."\" href=\"".htmlentities($item['link'])."\">".htmlentities($item['title'])."</a>$after";
			}
		} else {
			echo "There was an error processing the Obama RSS feed. Please check your sidebar widget configuration.";
		}
	} else {
		echo "An error occured! No RSS url was specified. Please check your sidebar widget configuration.";
	}
}

function obama_badge_widget_activate() {
	$default_options = array(
		'title'=>'Barack Obama News',
		'rssfeed'=>'http://www.barackobama.com/hqblog.xml',
		'badge'=>'http://www.barackobama.com/downloads/files2/Website_Chat/Site_Badges/normalsupport.jpg',
		'numitems'=>'5',
		'beforebadge' => '',
		'afterbadge' => ''
	);
	$options = get_option('obama_badge_widget');
	
	// set default options
	if (!is_array($options)) {
		update_option('obama_badge_widget', $default_options);
	} else {
		foreach ($options as $i => $value) {
			$default_options[$i] = $options[$i];
		}
		update_option('obama_badge_widget', $default_options);
	}
}

function obama_badge_widget_init() {
	if (!function_exists('register_sidebar_widget')) {
		return;
	}
	
	function obama_badge_widget($args) {
		// extract options
		extract($args);
		$options = get_option('obama_badge_widget');
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$rssfeed = htmlspecialchars_decode($options['rssfeed']);
		$badge = htmlspecialchars_decode($options['badge']);
		$numitems = htmlspecialchars_decode($options['numitems'], ENT_QUOTES);
		$beforebadge = htmlspecialchars_decode($options['beforebadge'], ENT_QUOTES);
		$afterbadge = htmlspecialchars_decode($options['afterbadge'], ENT_QUOTES);
		
		// print widget
		echo $beforebadge;
		?>
		<div class="obama-widget">
		<p class='obama-badge'><a target="_blank" href="https://donate.barackobama.com" title="Obama '08"><img src="<?php echo $badge; ?>" alt="Obama '08" title="Obama '08" border="0"  /></a></p>
		<?php if($title != '') :?>
		<p class='obama-feed-title'><?php echo $title; ?></p>
		<?php endif; ?>
		<ul class="obama-feed">
		<?php obama_badge_widget_getRSS($rssfeed,$numitems); ?>
		</ul>
		</div>
		<?php
		echo $afterbadge;
	}
	
	function obama_badge_widget_control() {
		$options = get_option('obama_badge_widget');
			
		if ( $_POST['obama_badge_widget-submit'] ) {
			$options['title'] = strip_tags(stripslashes($_POST['obama_badge_widget-title']));
			$options['rssfeed'] = stripslashes($_POST['obama_badge_widget-rssfeed']);
			$options['badge'] = stripslashes($_POST['obama_badge_widget-pic-url']);
			$options['numitems'] = stripslashes($_POST['obama_badge_widget-rss-items']);
			$options['beforebadge'] = stripslashes($_POST['obama_badge_widget-beforebadge']);
			$options['afterbadge'] = stripslashes($_POST['obama_badge_widget-afterbadge']);
			update_option('obama_badge_widget', $options);
		}
		
		$title = htmlspecialchars($options['title'], ENT_QUOTES);
		$rssfeed = htmlspecialchars($options['rssfeed'], ENT_QUOTES);
		$badge = htmlspecialchars_decode($options['badge']);
		$numitems = htmlspecialchars($options['numitems'], ENT_QUOTES);
		$beforebadge = htmlspecialchars($options['beforebadge'], ENT_QUOTES);
		$afterbadge = htmlspecialchars($options['afterbadge'], ENT_QUOTES);
		
?>
<p style="text-align:left;">
<label for="obama_badge_widget-title"><?php echo __('Barack RSS Feed Title:'); ?></label>
<input style="width: 200px;" id="obama_badge_widget-title" name="obama_badge_widget-title" type="text" value="<?php echo $title; ?>" />
<br/><label for="obama_badge_widget-pic-url"><?php _e('Choose a badge (<a href="http://www.mindsharestudios.com/barack_badges/"  target="_blank">see all</a>):'); ?></label>
<select id="obama_badge_widget-pic-url" name="obama_badge_widget-pic-url">
<?php 
	global $pics;
	foreach($pics as $picname=>$picurl) {
		echo '<option value="'.$picurl.'" '. ( $picurl == $badge ? "selected='selected'" : '' ) .' >'.$picname.'</option>';
	}
?>
</select>
<br/><label for="obama_badge_widget-rssfeed"><?php echo __('Barack RSS Feed URL:'); ?></label>
<input style="width: 200px;" id="obama_badge_widget-rssfeed" name="obama_badge_widget-rssfeed" type="text" value="<?php echo $rssfeed; ?>" />
<br/><label for="obama_badge_widget-rss-items"><?php _e('How many items would you like to display?'); ?></label>
<select id="obama_badge_widget-rss-items" name="obama_badge_widget-rss-items">
<?php
	for ( $i = 1; $i <= 20; ++$i ) {
		echo "<option value='$i' " . ( $numitems == $i ? "selected='selected'" : '' ) . ">$i</option>";
	}
?>
</select>
<br/><label for="obama_badge_widget-beforebadge"><?php echo __('Optional HTML/text before widget:'); ?></label>
<input style="width: 200px;" id="obama_badge_widget-beforebadge" name="obama_badge_widget-beforebadge" type="text" value="<?php echo $beforebadge; ?>" />
<br/><label for="obama_badge_widget-afterbadge"><?php echo __('Optional HTML/text after widget:'); ?></label>
<input style="width: 200px;" id="obama_badge_widget-afterbadge" name="obama_badge_widget-afterbadge" type="text" value="<?php echo $afterbadge; ?>" />
</p>
<input type="hidden" id="obama_badge_widget-submit" name="obama_badge_widget-submit" value="1" />
<?php
	}
	register_sidebar_widget(array('Barack Obama', 'widgets'), 'obama_badge_widget');
	register_widget_control(array('Barack Obama', 'widgets'), 'obama_badge_widget_control');
}

function obama_badge_widget_deactivate() {
	delete_option('obama_badge_widget');
}

// activation
register_activation_hook(__FILE__, 'obama_badge_widget_activate');
// initialization
add_action('plugins_loaded', 'obama_badge_widget_init');
// deactivation
register_deactivation_hook( __FILE__, 'obama_badge_widget_deactivate' );
?>